/*
 * IBM Confidential
 * OCO Source Materials
 * Component IBM Rational ROSE_RT BUILD : ROSE_RT
 * (c) Copyright IBM Corp. [1998], [2004] .All Rights Reserved.
 * 
 * The source code for this program is not published or
 * or otherwise divested of its trade secrets, irrespective
 * of what has been deposited with the U.S. Copyright Office.
 * 
 * 
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 * 
 */

#ifndef __RTAsciiDecoding_h__
#define __RTAsciiDecoding_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDecoding_h__
#include <RTDecoding.h>
#endif

#if OBJECT_DECODE

class  RTDataObject;
class  RTIBuffer;
struct RTUnknownObject;

class RTAsciiDecoding : public RTDecoding
{
public:
    explicit    RTAsciiDecoding( RTIBuffer * );
    virtual     ~RTAsciiDecoding( void );

    // All the get/put functions return an int which is non-zero
    // if the operation was successful. Otherwise, the following
    // function may be called to discover the reason for the
    // failure.
    int         getError( void );

    virtual int get( void **, const RTObject_class ** );

    // basic data types
    virtual int get_address ( void         * & );
    virtual int get_bool    ( bool           & );
    virtual int get_char    ( char           & );
#if RTUseFloatingPoint
    virtual int get_double  ( double         & );
    virtual int get_float   ( float          & );
#endif
    virtual int get_int     ( int            & );
    virtual int get_long    ( long           & );

	virtual int get_unsignedint( unsigned int & );
	virtual int get_unsignedlong( unsigned long & );
	virtual int get_unsignedshort( unsigned short & );
	virtual int get_unsignedchar( unsigned char & );
#if 0
#if _MSC_VER > 1000
    virtual int get_long_long( __int64 &  );
#else
    virtual int get_long_long( long long &  );
#endif
#endif

    virtual int get_short   ( short          & );
    virtual int get_uchar   ( unsigned char  & );
    virtual int get_unsigned( unsigned       & );
    virtual int get_ulong   ( unsigned long  & );
    virtual int get_ushort  ( unsigned short & );

    // a nul-terminated string
    virtual int get_string( char * & );

    // zero or more raw bytes
    virtual int get_opaque( int &, char * & );

    // an enumerated value
    virtual int get_enum( int &, int, const RTFieldDescriptor * );

    // a homogeneous array of objects
    virtual int get_array( void *, int, const RTObject_class * );

    // an indirect object
    virtual int get_indirect( void *, const RTObject_class * );

    // a structure
    virtual int get_struct( void *, const RTObject_class * );

protected:
    int                 getName( char * value, int length );
    RTUnknownObject   * getUnknown( const char * );

    int                 getNonWhite( char & );
    int                 getByte( char & );
    void                ungetByte( char );

    int                 getFieldListStart( void );
    int                 getFieldName( char * value, int length );
    int                 getFieldSeparator( void );
    int                 getFieldListFinish( void );

private:
    enum              { UngetMax = 3 };

    int                 unget_size;
    char                unget_buffer[ UngetMax ];
    RTIBuffer         * input;

    // unavailable methods
    RTAsciiDecoding( const RTAsciiDecoding & );
    RTAsciiDecoding & operator=( const RTAsciiDecoding & );
}; //lint !e1712

#endif // OBJECT_DECODE

#endif // __RTAsciiDecoding_h__
