/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#include <RTMain.h>
#include <taskLib.h>

extern "C"
{
#if PERFORM_CTOR_DTOR
    typedef void ( * VoidFunction )( void );

    extern VoidFunction _ctors[];
    extern VoidFunction _dtors[];
#endif

int rtsMain( char * a01, char * a02, char * a03, char * a04,
	     char * a05, char * a06, char * a07, char * a08,
	     char * a09, char * a10, char * a11, char * a12,
	     char * a13, char * a14, char * a15, char * a16,
	     char * a17, char * a18, char * a19, char * a20 )
{
#if PERFORM_CTOR_DTOR
    // construct/initialize globals

    for( VoidFunction * ctor = _ctors; *ctor != (VoidFunction)0; ++ctor )
	(*ctor)();
#endif

    int          argc;
    const char * argv[ 22 ];

    argv[  0 ] = "MicroRTS";
    argv[  1 ] = a01; argv[  2 ] = a02; argv[  3 ] = a03; argv[  4 ] = a04;
    argv[  5 ] = a05; argv[  6 ] = a06; argv[  7 ] = a07; argv[  8 ] = a08;
    argv[  9 ] = a09; argv[ 10 ] = a10;

#if defined( VXWORKS60 )
	argv[ 11 ] = (const char *)0;
#else
	argv[ 11 ] = a11; argv[ 12 ] = a12; argv[ 13 ] = a13; argv[ 14 ] = a14;
	argv[ 15 ] = a15; argv[ 16 ] = a16; argv[ 17 ] = a17; argv[ 18 ] = a18;
	argv[ 19 ] = a19; argv[ 20 ] = a20; argv[ 21 ] = (const char *)0;
#endif

    for( argc = 0; argv[ ++argc ] != (const char *)0; )
    {
	// search for first null
    }

    int result = RTMain::entryPoint( argc, argv );

#if PERFORM_CTOR_DTOR
    // destruct globals

    for( VoidFunction * dtor = _dtors; *dtor != (VoidFunction)0; ++dtor )
	(*dtor)();
#endif

    return result;
}

} // extern "C"
