/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#include <RTMemoryUtil.h>

#ifdef NO_BUILTIN_MEM

int RTMemoryUtil::memcmp( const void * m1, const void * m2, int len )
{
    const unsigned char * c1 = (const unsigned char *)m1;
    const unsigned char * c2 = (const unsigned char *)m2;

    while( len-- )
    {
	if( *c1 != *c2 )
	    return *c1 > *c2 ? 1 : -1;
	++c1;
	++c2;
    }

    return 0;
}

#else

#if defined( VXWORKS60 ) 
#include <string.h>
#else
#include <RTstdio.h>
#endif

int RTMemoryUtil::memcmp( const void * m1, const void * m2, int len )
{
    return ::memcmp( m1, m2, (size_t)len );
}

#endif
