/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#include <RTDiag.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

#include <errno.h>
#include <objLib.h>
#include <sysLib.h>

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
    static int  initialized = 0;
    static long clock_period;
    long        delta;

    if( ! initialized )
    {
	clock_period = 1000000000 / sysClkRateGet();
	initialized = 1;
    }

    if( (delta = expireTime.ticksFromNow( clock_period )) <= 0 )
    {
	// already at or past expiry time
    }
    else if( semTake( sem_id, delta ) == OK )
    {
	// semaphore was signalled
    }
    else if( errno == S_objLib_OBJ_TIMEOUT )
    {
	// wait timed out
    }
    else
    {
	RTDiag::panic( "semTake(sync::timedwait)" );
    }
}
