/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

#if defined( VXWORKS60 )
#include <in.h>
#endif

extern "C" int RTinet_accept( int              listener,
			      RTinet_address * address,
			      RTinet_port    * port )
{
    int               sock;
    sockaddr_in       peer;
    SocketAddressSize peer_size = sizeof( peer );

    for(;;)
    {
	//lint -save -e740
	sock = INET_accept( listener,
			    (SocketAddress *)&peer,
			    &peer_size );
	//lint -restore

	if( sock == INET_NO_SOCKET )
	{
#if defined( INET_EINTR ) || defined( INET_EAGAIN )
	    int err = INET_error( listener );
#endif

#ifdef INET_EINTR
	    if( err == INET_EINTR )
		continue;
#endif

#ifdef INET_EAGAIN
	    if( err == INET_EAGAIN )
		continue;
#endif
	}
	else if( RTinet_async( sock ) == 0 || RTinet_nonblocking( sock ) == 0 )
	{
	    RTinet_close( sock );
	    sock = INET_NO_SOCKET;
	}
	else
	{
	    RTMemoryUtil::memcpy( address, &peer.sin_addr,
					   (int)sizeof( *address ) );
	    *port = ntohs( peer.sin_port );
	}

	return sock;
    }
}
