/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#ifndef __RTtcp_h__
#define __RTtcp_h__ included

#define __INCstringh // avoid including string.h

#include <errno.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sockLib.h>
#include <hostLib.h>
#include <ioLib.h>
#include <net/if.h>

typedef struct sockaddr  SocketAddress;
typedef int              SocketAddressSize;

#define INET_HaveLength  1

#define INET_accept      accept
#define INET_bind        bind
#define INET_close       close
#define INET_connect     connect
#define INET_error( sd ) errno
#define INET_getsockname getsockname
#define INET_listen      listen
#define INET_lookup      gethostbyname
#define INET_recv        recv
#define INET_recvfrom    recvfrom
#define INET_setsockopt  setsockopt
#define INET_socket      socket

#define INET_ioctl( sock, cmd, arg ) \
			 ioctl( (sock), (cmd), (int)arg )

#define INET_send( sock, data, size, flags ) \
			 send( (sock), (char *)(data), (size), (flags) )

#define INET_sendto( sock, data, size, flags, addr, addr_len ) \
			 sendto( (sock), (char *)(data), (size), (flags), \
				 (addr), (addr_len) )

#define INET_EALREADY    EALREADY
#define INET_EINPROGRESS EINPROGRESS
#define INET_EINTR       EINTR
#define INET_EISCONN     EISCONN
#define INET_EWOULDBLOCK EWOULDBLOCK

#if _BYTE_ORDER == _LITTLE_ENDIAN

    // The declaration of sockaddr_in in netinet/in.h was broken between
    // versions 1.0.0 and 1.0.1: the field
    //
    //     u_short sin_family;
    //
    // was replaced by the pair of fields
    //
    //     u_char sin_len;
    //     u_char sin_family;
    //
    // However, the kernel behaves as if it uses the old declaration.
    // This doesn't matter if _BYTE_ORDER == _BIG_ENDIAN, but i960 and
    // x86 processors have those bytes swapped.
    // We adapt by using the sin_len field instead of sin_family.

#   define sin_family sin_len

#endif

#endif // __RTtcp_h__
