/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

#if defined( VXWORKS60 )
#include <in.h>
#endif

extern "C" int RTinet_accept( int              listener,
			      RTinet_address * address,
			      RTinet_port    * port )
{
    int               sock;
    sockaddr_in       peer;
    SocketAddressSize peer_size = sizeof( peer );

    for(;;)
    {
	//lint -save -e740
	sock = INET_accept( listener,
			    (SocketAddress *)&peer,
			    &peer_size );
	//lint -restore

	if( sock == INET_NO_SOCKET )
	{
#if defined( INET_EINTR ) || defined( INET_EAGAIN )
	    int err = INET_error( listener );
#endif

#ifdef INET_EINTR
	    if( err == INET_EINTR )
		continue;
#endif

#ifdef INET_EAGAIN
	    if( err == INET_EAGAIN )
		continue;
#endif
	}
	else if( RTinet_async( sock ) == 0 || RTinet_nonblocking( sock ) == 0 )
	{
	    RTinet_close( sock );
	    sock = INET_NO_SOCKET;
	}
	else
	{
	    RTMemoryUtil::memcpy( address, &peer.sin_addr,
					   (int)sizeof( *address ) );
	    *port = ntohs( peer.sin_port );
	}

	return sock;
    }
}
